import 'package:ef/ef.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/svg.dart';
import 'package:flutterflow_ui/flutterflow_ui.dart';
import 'package:vbvs_app/common/color/appConstants.dart';
import 'package:vbvs_app/common/util/FitTool.dart';
import 'package:vbvs_app/common/util/MyUtils.dart';
import 'package:vbvs_app/component/tool/ClickableContainer.dart';
import 'package:vbvs_app/pages/device_bind/componnet/bind_dialog.dart';
import 'package:vbvs_app/pages/sleep_report/chart/FatigueCircleIndicator.dart';
import 'package:EasyDartModule/EasyDartModule.dart' as es;

class HeartHealthWidget extends StatefulWidget {
  var sleepReport;
  HeartHealthWidget({super.key, required this.sleepReport});

  @override
  State<HeartHealthWidget> createState() => _HeartHealthWidgetState();
}

class _HeartHealthWidgetState extends State<HeartHealthWidget> {
  @override
  void setState(VoidCallback callback) {
    super.setState(callback);
  }

  @override
  void initState() {
    super.initState();
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    try {
      if (widget.sleepReport == null ||
          widget.sleepReport['mha'] == null ||
          widget.sleepReport['mha'].isEmpty) {
        return Container();
      }

      List data = widget.sleepReport['mha'];
      var showLabel = convertMentalHealthData(data);
      return Container(
        width: double.infinity,
        decoration: BoxDecoration(
          color: themeController.currentColor.sc5,
          borderRadius: BorderRadius.circular(
              AppConstants().normal_container_radius), // 你可以按需调整圆角半径
        ),
        child: Padding(
          padding:
              EdgeInsetsDirectional.fromSTEB(26.rpx, 29.rpx, 26.rpx, 0.rpx),
          child: Column(
            mainAxisSize: MainAxisSize.max,
            children: [
              Container(
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Text(
                      "心理健康评估".tr,
                      style: TextStyle(
                          color: themeController.currentColor.sc3,
                          fontSize: AppConstants().title_text_fontSize),
                    ),
                    ClickableContainer(
                      backgroundColor: Colors.transparent,
                      highlightColor: Colors.white, // 或设置为你需要的水波纹颜色
                      padding: EdgeInsetsDirectional.fromSTEB(
                          14.rpx, 0.rpx, 14.rpx, 0), //
                      borderRadius: 0.rpx, // 圆形点击区域
                      onTap: () {
                        showTipDialog(
                          context,
                          Container(
                            child: Text(
                              "心理健康评估介绍".tr,
                              style: TextStyle(
                                fontSize: 26.rpx,
                                color: themeController.currentColor.sc3,
                              ),
                            ),
                          ),
                        );
                      },
                      child: Container(
                        padding: EdgeInsetsDirectional.fromSTEB(
                            0, 0.rpx, 0.rpx, 0), // 外部 padding 移到内部
                        width: 28.rpx,
                        height: 28.rpx,
                        child: SvgPicture.asset(
                          'assets/img/icon/explain.svg',
                          fit: BoxFit.cover,
                          color: themeController.currentColor.sc4,
                        ),
                      ),
                    ),
                  ],
                ),
              ),
              SizedBox(
                height: 104.rpx,
              ),
              Padding(
                padding: EdgeInsetsDirectional.fromSTEB(
                    30.rpx, 0.rpx, 30.rpx, 0.rpx),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: [
                    FatigueCircleIndicator(
                      data: showLabel[0],
                    ),
                    FatigueCircleIndicator(
                      data: showLabel[1],
                    ),
                  ].divide(SizedBox(
                    width: 110.rpx,
                  )),
                ),
              ),
              SizedBox(
                height: 72.rpx,
              ),
            ],
          ),
        ),
      );
    } catch (e) {
      es.EasyDartModule.logger.error("打鼾监测绘制异常${e}");
      return Container();
    }
  }

  List<Map<String, dynamic>> convertMentalHealthData(List data) {
    return data.map<Map<String, dynamic>>((item) {
      final String? colorStr = item['color'];
      final int value = item['value'] ?? 0;
      final String explain =
          (item['tips'] != null && (item['tips'] as String).trim().isNotEmpty)
              ? item['tips']
              : '未知数据'.tr;

      return {
        'name': item['name'],
        'color': colorStr != null && colorStr.isNotEmpty
            ? stringToColor(colorStr)
            : stringToColor("#00C1AA"), // 默认红色
        'percent': value,
        'explain': item['level'],
        "bottomColor": Colors.grey,
      };
    }).toList();
  }
}
